package com.sun.org.apache.xml.internal.utils;

import java.util.Enumeration;
import org.w3c.dom.Element;
import java.util.Vector;
import org.w3c.dom.Document;
import org.w3c.dom.Node;
import java.util.Hashtable;

public abstract class Hashtree2Node
{
    public Hashtree2Node() {
    }
    
    public static void appendHashToNode(Hashtable hash, String name, Node container, Document factory) {
        if (null == container || null == factory || null == hash) {
            return;
        }
        String elemName = null;
        if (null == name || "".equals(name)) {
            elemName = "appendHashToNode";
        }
        else {
            elemName = name;
        }
        try {
            Element hashNode = factory.createElement(elemName);
            container.appendChild(hashNode);
            Enumeration<Object> keys = hash.keys();
            Vector<Object> v = new Vector();
            while (keys.hasMoreElements()) {
                Object key = keys.nextElement();
                String keyStr = key.toString();
                Object item = hash.get(key);
                if ((item instanceof Hashtable)) {
                    v.addElement(keyStr);
                    v.addElement((Object)item);
                }
                else {
                    try {
                        Element node = factory.createElement("item");
                        node.setAttribute("key", keyStr);
                        node.appendChild(factory.createTextNode((String)item));
                        hashNode.appendChild(node);
                    }
                    catch (Exception e) {
                        Element node2 = factory.createElement("item");
                        node2.setAttribute("key", keyStr);
                        node2.appendChild(factory.createTextNode("ERROR: Reading " + key + " threw: " + e.toString()));
                        hashNode.appendChild(node2);
                    }
                }
            }
            keys = v.elements();
            while (keys.hasMoreElements()) {
                String n = (String)keys.nextElement();
                Hashtable<Object, Object> h = (Hashtable)keys.nextElement();
                appendHashToNode(h, n, hashNode, factory);
            }
        }
        catch (Exception e2) {
            e2.printStackTrace();
        }
        return;
    }
}
